VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "ComDlg32.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "VBC-OCR"
   ClientHeight    =   6405
   ClientLeft      =   45
   ClientTop       =   390
   ClientWidth     =   12270
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6405
   ScaleWidth      =   12270
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame frFromHandle 
      Caption         =   "OCR from ImageHandle"
      Height          =   675
      Left            =   6000
      TabIndex        =   5
      Top             =   60
      Width           =   2235
      Begin VB.CommandButton cmdImageHandle 
         Caption         =   "ImageHandle"
         Height          =   315
         Left            =   90
         TabIndex        =   6
         Top             =   270
         Width           =   2025
      End
   End
   Begin MSComDlg.CommonDialog CDG 
      Left            =   8400
      Top             =   150
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.TextBox txtOcr 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   5565
      Left            =   60
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   4
      Top             =   780
      Width           =   12165
   End
   Begin VB.Frame frOpenFile 
      Caption         =   "OCR from ImageFile"
      Height          =   675
      Left            =   3720
      TabIndex        =   2
      Top             =   60
      Width           =   2235
      Begin VB.CommandButton cmdOpenFile 
         Caption         =   "Open Image"
         Height          =   315
         Left            =   90
         TabIndex        =   3
         Top             =   270
         Width           =   2025
      End
   End
   Begin VB.Frame frAvailableOcrLanguages 
      Caption         =   "Select OCR Languages"
      Height          =   675
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   3615
      Begin VB.ComboBox cbAvailableOcrLanguages 
         Height          =   315
         Left            =   90
         Style           =   2  'Dropdown List
         TabIndex        =   1
         Top             =   270
         Width           =   3435
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 06/2022

Option Explicit

Private cOCR As clsOCR

Private Sub Form_Load()
    Set cOCR = New clsOCR
    If cOCR.GetIsOcrInitialized Then
        Dim lngAvailableOcrLanguageCount As Long
        lngAvailableOcrLanguageCount = cOCR.GetAvailableOcrLanguagesCount
        If lngAvailableOcrLanguageCount > 0 Then
            Dim lngAvailableOcrLanguageIndex As Long
            For lngAvailableOcrLanguageIndex = 0 To lngAvailableOcrLanguageCount - 1
                cbAvailableOcrLanguages.AddItem cOCR.GetAvailableOcrLanguageDisplayName(lngAvailableOcrLanguageIndex) & " (" & _
                                                cOCR.GetAvailableOcrLanguageTag(lngAvailableOcrLanguageIndex) & ")"
            Next
            cbAvailableOcrLanguages.ListIndex = 0
        Else
            cbAvailableOcrLanguages.Enabled = False
            cmdOpenFile.Enabled = False
            cmdImageHandle.Enabled = False
        End If
    End If
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Set cOCR = Nothing
End Sub

Private Sub cbAvailableOcrLanguages_Click()
    cmdOpenFile.Enabled = False
    cmdImageHandle.Enabled = False
    If cOCR.InitializeOcrEngineWithLanguageIndex(cbAvailableOcrLanguages.ListIndex) Then
        cmdOpenFile.Enabled = True
        cmdImageHandle.Enabled = True
    End If
End Sub

Private Sub cmdOpenFile_Click()

    Dim strImageFile As String
    
    With CDG
        .DialogTitle = "Open Image"
        .Flags = cdlOFNFileMustExist Or cdlOFNHideReadOnly
        .Filter = "BMP Files (*.bmp)|*.bmp|" & _
                  "JPG Files (*.jpg)|*.jpg|" & _
                  "GIF Files (*.gif)|*.gif|"
        .FilterIndex = 2
        .ShowOpen
        strImageFile = .FileName
    End With
    
    If Len(strImageFile) > 0 Then
        
        Me.Caption = "Bitte warten..."
        DoEvents
        
        If cOCR.GetOcrResultsFromFile(strImageFile) Then
            txtOcr.Text = cOCR.GetOcrResultTextCompleteWithLineBreak
            Me.Caption = "Fertig"
            DoEvents
    
            'Debug.Print cOCR.GetOcrResultTextAngle
            'Debug.Print cOCR.GetOcrResultTextComplete
            'Debug.Print cOCR.GetMaxImageDimensionForOcr
    
'            Dim lngTextLineCount As Long
'            lngTextLineCount = cOCR.GetOcrResultTextLineCount
'            If lngTextLineCount > 0 Then
'                Dim lngTextLineIndex As Long
'                For lngTextLineIndex = 0 To lngTextLineCount - 1
'                   Debug.Print "TextLine" & Format$(lngTextLineIndex + 1, String$(Len(CStr(lngTextLineCount)), "0")) & _
'                                " = " & cOCR.GetOcrResultTextLineFromIndex(lngTextLineIndex)
'
'                   Dim lngTextLineWordsCount As Long
'                   lngTextLineWordsCount = cOCR.GetOcrResultTextLineWordsCountFromIndex(lngTextLineIndex)
'                   If lngTextLineWordsCount > 0 Then
'                       Dim lngTextLineWordIndex As Long
'                       For lngTextLineWordIndex = 0 To lngTextLineWordsCount - 1
'                           Dim tRectF As RECTF
'                           tRectF = cOCR.GetOcrResultTextLineWordRectFromIndex(lngTextLineIndex, lngTextLineWordIndex)
'                           Debug.Print vbTab & "TextLineWord" & Format$(lngTextLineWordIndex + 1, String$(Len(CStr(lngTextLineWordsCount)), "0")) & _
'                                       " = " & cOCR.GetOcrResultTextLineWordFromIndex(lngTextLineIndex, lngTextLineWordIndex) & _
'                                       " [Left: " & CStr(tRectF.Left) & ", Top: " & CStr(tRectF.Top) & _
'                                       ", Right: " & CStr(tRectF.Right) & ", Bottom: " & CStr(tRectF.Bottom) & "]"
'
'                       Next
'                   End If
'                Next
'            End If
        End If
    End If
End Sub

Private Sub cmdImageHandle_Click()

    Dim bmp As StdPicture
    Set bmp = LoadPicture(App.Path & "\Sample3_de.jpg")
    If Not bmp Is Nothing Then
        Me.Caption = "Bitte warten..."
        DoEvents
        If cOCR.GetOcrResultsFromHBitmap(bmp.Handle) Then
            txtOcr.Text = cOCR.GetOcrResultTextCompleteWithLineBreak
            Me.Caption = "Fertig"
            DoEvents
        End If
        Set bmp = Nothing
    End If
End Sub

